package ejb31.war.servlet;

import java.io.*;
import java.net.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.ejb.EJB;
import javax.sql.DataSource;
import javax.transaction.UserTransaction;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class AnnotatedServlet extends HttpServlet {
   
    @EJB
    private AnnotatedEJBLocal localEJB;
    
    @EJB
    private StringService strRef;

    @EJB
    private AnnotatedEJBRemote remoteEJB;

    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        response.setContentType("text/plain");
        PrintWriter out = response.getWriter();
        boolean status = false;
        try {
            
            out.println("-------AnnotatedServlet--------");  
            out.println("AnntatedServlet at " + request.getContextPath ());

            String testcase = request.getParameter("tc");
            out.println("testcase = " + testcase);
            if (testcase != null) {

	      if ("LocalEJBInjectLookup".equals(testcase)){

		out.println("Local EJB:");
		out.println("@EJB Injection="+localEJB);
		String localEJBName = null;
		
		if (localEJB != null) {
		  localEJBName = localEJB.getName();
		  out.println("@EJB.getName()=" + localEJBName);
		}

		Object localEJBLookup = lookupField("localEJB");
		out.println("JNDI Lookup=" + localEJBLookup );
		if (localEJB != null &&
		    localEJBLookup != null &&
		    "foo".equals(localEJBName) &&
		    localEJBLookup.equals(localEJB)){
		  status = true;
		}
	      } else if ("RemoteEJBInjectLookup".equals(testcase)){
		Object remoteEJBLookup = lookupField("remoteEJB"); ;
		out.println("Remote EJB");
		out.println("@EJB Injection=" + remoteEJB);
		out.println("JNDI lookup=" + lookupField("remoteEJB"));
		if (remoteEJB != null &&
		    remoteEJBLookup != null &&
		    remoteEJBLookup.equals(remoteEJB)){
		  status = true;
		}
	      } else if ("EJBDataSourceInject".equals(testcase)){
		DataSource dsInject = null;
		if (localEJB != null) {
		  dsInject = localEJB.getDs();
		  out.println("DataSource");
		  out.println("@Resource for DS=" + dsInject);
		}
		if (dsInject != null &&
		    dsInject.toString().contains("DataSource")){
		  status = true;
		}
	      } else if ("EJBUserTransactionInject".equals(testcase)){
		UserTransaction utxInject = null;
		if (localEJB != null) {
		  utxInject = localEJB.getUtx();
		  out.println("@EJB.getUtx()=" + utxInject );
		}

		if (utxInject != null &&
		    utxInject.toString().contains("UserTransaction")){
		  status = true;
		}
	      } else if ("StringService".equals(testcase)){
		out.println("String Service Reference:");
		out.println("@EJB="+strRef);
		boolean dataTest =  strRef.isPalindrome("data");
		out.println("isPalindrome(\"data\"): " + dataTest);
		boolean edatadeTest =  strRef.isPalindrome("EDATADE");
		out.println("isPalindrome(\"EDATADE\"): " + edatadeTest);
		
		if (strRef != null && !dataTest && edatadeTest) {
		  status = true;
		}
	      } else {
		out.println("No such testcase");
	      }
	  }
        } catch (Exception ex ) {
            ex.printStackTrace();
            System.out.println("servlet test failed");
            throw new ServletException(ex);
        } finally { 
            if (status) 
	      out.println("Test:Pass");
            else
	      out.println("Test:Fail");
            out.close();
        }
    } 

    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 


    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    public String getServletInfo() {
        return "AnnontatedServlet";
    }

    private Object lookupField(String name) {
        try {
            return new InitialContext().lookup("java:comp/env/" + getClass().getName() + "/" + name);
        } catch (NamingException e) {
            return null;
        }
    }

}



